<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Model;

use FiloBlu\ExtAmastyGeoipRedirect\Model\ResourceModel\Continent\CollectionFactory;
use Magento\Framework\Data\Collection\AbstractDb;
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\Model\Context;
use Magento\Framework\Model\ResourceModel\AbstractResource;
use Magento\Framework\Registry;

/**
 *
 */
class CountryContinent extends AbstractModel
{

    protected $_countryContinentCollectionFactory;
    protected $_continentCollectionFactory;

    protected $_countryContinentArray;
    protected $_continentArray;

    public function __construct(
        ResourceModel\CountryContinent\CollectionFactory $countryContinentCollectionFactory,
        CollectionFactory $continentCollectionFactory,
        Context $context,
        Registry $registry,
        AbstractResource $resource = null,
        AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        $this->_countryContinentCollectionFactory = $countryContinentCollectionFactory;
        $this->_continentCollectionFactory = $continentCollectionFactory;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    public function getContinentByCountry($countryId)
    {
        if (!$this->_countryContinentArray) {
            $countryContinentCollection = $this->_countryContinentCollectionFactory->create();
            $countryContinentCollection->addFieldToSelect(['continent_id', 'country_id']);
            foreach ($countryContinentCollection as $countryContinent) {
                $this->_countryContinentArray[$countryContinent->getCountryId()] = $countryContinent->getContinentId();
            }
        }

        if (!$this->_continentArray) {
            $continentCollection = $this->_continentCollectionFactory->create();
            $continentCollection->addFieldToSelect('*');
            foreach ($continentCollection as $continent) {
                $this->_continentArray[$continent->getContinentId()] = $continent;
            }
        }

        return $this->_continentArray[$this->_countryContinentArray[$countryId]];
    }

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init(ResourceModel\CountryContinent::class);
    }

}
